Index: /trunk/src/bp-core/classes/class-bp-core-nav.php
===================================================================
--- /trunk/src/bp-core/classes/class-bp-core-nav.php	(revision 10745)
+++ /trunk/src/bp-core/classes/class-bp-core-nav.php	(revision 10745)
@@ -0,0 +1,400 @@
+<?php
+/**
+ * Core component class.
+ *
+ * @package BuddyPress
+ * @subpackage Core
+ * @since  2.6.0
+ */
+
+// Exit if accessed directly.
+defined( 'ABSPATH' ) || exit;
+
+/**
+ * BuddyPress Nav.
+ *
+ * This class is used to build each component's navigation.
+ *
+ * @since 2.6.0
+ */
+class BP_Core_Nav {
+	/**
+	 * An associative array containing the nav items for the object ID.
+	 *
+	 * @since 2.6.0
+	 * @var array
+	 */
+	protected $nav;
+
+	/**
+	 * The current object ID.
+	 *
+	 * @since 2.6.0
+	 * @var int
+	 */
+	private $object_id;
+
+	/**
+	 * Initializes the Nav belonging to the specified object.
+	 *
+	 * @since 2.6.0
+	 *
+	 * @param int $object_id The item ID to build the nav for. Default is the displayed user ID.
+	 */
+	public function __construct( $object_id = 0 ) {
+		if ( empty( $object_id ) ) {
+			$this->object_id = (int) bp_displayed_user_id();
+		} else {
+			$this->object_id = (int) $object_id;
+		}
+
+		$this->nav[ $this->object_id ] = array();
+	}
+
+	/**
+	 * Checks whether a nav item is set.
+	 *
+	 * @since 2.6.0
+	 *
+	 * @param  string $key The requested nav slug.
+	 * @return bool True if the nav item is set, false otherwise.
+	 */
+	public function __isset( $key ) {
+		return isset( $this->nav[ $this->object_id ][ $key ] );
+	}
+
+	/**
+	 * Gets a nav item.
+	 *
+	 * @since 2.6.0
+	 *
+	 * @param  string $key The requested nav slug.
+	 * @return mixed The value corresponding to the requested nav item.
+	 */
+	public function __get( $key ) {
+		if ( ! isset( $this->nav[ $this->object_id ][ $key ] ) ) {
+			$this->nav[ $this->object_id ][ $key ] = null;
+		}
+
+		return $this->nav[ $this->object_id ][ $key ];
+	}
+
+	/**
+	 * Sets a nav item.
+	 *
+	 * @since 2.6.0
+	 *
+	 * @param  string  $key   The requested nav slug.
+	 * @param  mixed   $value The value of the nav item.
+	 */
+	public function __set( $key, $value ) {
+		if ( is_array( $value ) ) {
+			$value['primary'] = true;
+		}
+
+		$this->nav[ $this->object_id ][ $key ] = new BP_Core_Nav_Item( $value );
+	}
+
+	/**
+	 * Gets a specific nav item or array of nav items.
+	 *
+	 * @since 2.6.0
+	 *
+	 * @param  string $key The nav item slug to get. Optional.
+	 * @return mixed       An array of nav item, a single nav item, or null if none found.
+	 */
+	public function get( $key = '' ) {
+		$return = null;
+
+		// Return the requested nav item.
+		if ( ! empty( $key ) ) {
+			if ( ! isset( $this->nav[ $this->object_id ][ $key ] ) ) {
+				$return = null;
+			} else {
+				$return = $this->nav[ $this->object_id ][ $key ];
+			}
+
+		// Return all nav item items.
+		} else {
+			$return = $this->nav[ $this->object_id ];
+		}
+
+		return $return;
+	}
+
+	/**
+	 * Adds a new nav item.
+	 *
+	 * @since 2.6.0
+	 *
+	 * @param array $args The nav item's arguments.
+	 * @return BP_Core_Nav_Item
+	 */
+	public function add_nav( $args ) {
+		if ( empty( $args['slug'] ) ) {
+			return false;
+		}
+
+		// We have a child and the parent exists.
+		if ( ! empty( $args['parent_slug'] ) ) {
+			$slug              = $args['parent_slug'] . '/' . $args['slug'];
+			$args['secondary'] = true;
+
+		// This is a parent.
+		} else {
+			$slug            = $args['slug'];
+			$args['primary'] = true;
+		}
+
+		// Add to the nav.
+		$this->nav[ $this->object_id ][ $slug ] = new BP_Core_Nav_Item( $args );
+
+		return $this->nav[ $this->object_id ][ $slug ];
+	}
+
+	/**
+	 * Edits a nav item.
+	 *
+	 * @since 2.6.0
+	 *
+	 * @param array  $args        The nav item's arguments.
+	 * @param string $slug        The slug of the nav item.
+	 * @param string $parent_slug The slug of the parent nav item (required to edit a child).
+	 * @return BP_Core_Nav_Item
+	 */
+	public function edit_nav( $args = array(), $slug = '', $parent_slug = '' ) {
+		if ( empty( $slug ) ) {
+			return false;
+		}
+
+		// We're editing a parent!
+		if ( empty( $parent_slug ) ) {
+			$nav_items = $this->get_primary( array( 'slug' => $slug ), false );
+
+			if ( ! $nav_items ) {
+				return false;
+			}
+
+			$nav_item = reset( $nav_items );
+			$this->nav[ $this->object_id ][ $slug ] = new BP_Core_Nav_Item( wp_parse_args( $args, (array) $nav_item ) );
+
+			// Return the edited object.
+			return $this->nav[ $this->object_id ][ $slug ];
+
+		// We're editing a child.
+		} else {
+			$sub_items = $this->get_secondary( array( 'parent_slug' => $parent_slug, 'slug' => $slug ), false );
+
+			if ( ! $sub_items ) {
+				return false;
+			}
+
+			$sub_item = reset( $sub_items );
+
+			$params = wp_parse_args( $args, (array) $sub_item );
+
+			// When we have parents, it's for life, we can't change them!
+			if ( empty( $params['parent_slug'] ) || $parent_slug !== $params['parent_slug'] ) {
+				return false;
+			}
+
+			$this->nav[ $this->object_id ][ $parent_slug . '/' . $slug ] = new BP_Core_Nav_Item( $params );
+
+			// Return the edited object.
+			return $this->nav[ $this->object_id ][ $parent_slug . '/' . $slug ];
+		}
+	}
+
+	/**
+	 * Unset an item or a subitem of the nav.
+	 *
+	 * @since 2.6.0
+	 *
+	 * @param string $key     The slug of the main item.
+	 * @param string $sub_key The slug of the sub item.
+	 * @return bool|callable|array False on failure, the screen function(s) on success.
+	 */
+	public function delete_nav( $slug, $parent_slug = '' ) {
+		if ( empty( $slug ) ) {
+			return false;
+		}
+
+		// We're deleting a child
+		if ( ! empty( $parent_slug ) ) {
+
+			// Validate the subnav
+			$sub_items = $this->get_secondary( array( 'parent_slug' => $parent_slug, 'slug' => $slug ), false );
+
+			if ( ! $sub_items ) {
+				return false;
+			}
+
+			$sub_item = reset( $sub_items );
+
+			if ( empty( $sub_item->slug ) ) {
+				return false;
+			}
+
+			// Delete the child
+			unset( $this->nav[ $this->object_id ][ $parent_slug . '/' . $slug ] );
+
+			// Return the deleted item's screen function
+			return array( $sub_item->screen_function );
+
+		// We're deleting a parent
+		} else {
+			// Validate the nav
+			$nav_items = $this->get_primary( array( 'slug' => $slug ), false );
+
+			if ( ! $nav_items ) {
+				return false;
+			}
+
+			$nav_item = reset( $nav_items );
+
+			if ( empty( $nav_item->slug ) ) {
+				return false;
+			}
+
+			$screen_functions = array( $nav_item->screen_function );
+
+			// Life's unfair, children won't survive the parent :(
+			$sub_items = $this->get_secondary( array( 'parent_slug' => $nav_item->slug ), false );
+
+			if ( ! empty( $sub_items ) ) {
+				foreach ( $sub_items as $sub_item ) {
+					$screen_functions[] = $sub_item->screen_function;
+
+					// Delete the child
+					unset( $this->nav[ $this->object_id ][ $nav_item->slug . '/' . $sub_item->slug ] );
+				}
+			}
+
+			// Delete the parent.
+			unset( $this->nav[ $this->object_id ][ $nav_item->slug ] );
+
+			// Return the deleted item's screen functions.
+			return array_unique( $screen_functions );
+		}
+	}
+
+	/**
+	 * Sorts a list of nav items.
+	 *
+	 * @since 2.6.0
+	 *
+	 * @param array $items The nav items to sort.
+	 * @return array
+	 */
+	public function sort_nav( $items ) {
+		$sorted = array();
+
+		foreach ( $items as $item ) {
+			// Default position
+			$position = 99;
+
+			if ( isset( $item->position ) ) {
+				$position = (int) $item->position;
+			}
+
+			// If position is already taken, move to the first next available
+			if ( isset( $sorted[ $position ] ) ) {
+				$sorted_keys = array_keys( $sorted );
+
+				do {
+					$position += 1;
+				} while ( in_array( $position, $sorted_keys ) );
+			}
+
+			$sorted[ $position ] = $item;
+		}
+
+		ksort( $sorted );
+		return $sorted;
+	}
+
+	/**
+	 * Gets the primary nav items.
+	 *
+	 * @since 2.6.0
+	 *
+	 * @param  array $args Filters to select the specific primary items. See wp_list_filter().
+	 * @param  bool  $sort True to sort the nav items. False otherwise.
+	 * @return array The list of primary objects nav
+	 */
+	public function get_primary( $args = array(), $sort = true ) {
+		$params = wp_parse_args( $args, array( 'primary' => true ) );
+
+		// This parameter is not overridable
+		if ( empty( $params['primary'] ) ) {
+			return false;
+		}
+
+		$primary_nav = wp_list_filter( $this->nav[ $this->object_id ], $params );
+
+		if ( ! $primary_nav ) {
+			return false;
+		}
+
+		if ( true !== $sort ) {
+			return $primary_nav;
+		}
+
+		return $this->sort_nav( $primary_nav );
+	}
+
+	/**
+	 * Gets the secondary nav items.
+	 *
+	 * @since 2.6.0
+	 *
+	 * @param  array $args Filters to select the specific secondary items. See wp_list_filter().
+	 * @param  bool  $sort True to sort the nav items. False otherwise.
+	 * @return array The list of secondary objects nav
+	 */
+	public function get_secondary( $args = array(), $sort = true ) {
+		$params = wp_parse_args( $args, array( 'parent_slug' => '' ) );
+
+		// No need to search children if the parent is not set
+		if ( empty( $params['parent_slug'] ) && empty( $params['secondary'] ) ) {
+			return false;
+		}
+
+		$secondary_nav = wp_list_filter( $this->nav[ $this->object_id ], $params );
+
+		if ( ! $secondary_nav ) {
+			return false;
+		}
+
+		if ( true !== $sort ) {
+			return $secondary_nav;
+		}
+
+		return $this->sort_nav( $secondary_nav );
+	}
+
+	/**
+	 * Gets a nested list of visible nav items.
+	 *
+	 * @since 2.6.0
+	 *
+	 * @return array The list of visible nav items.
+	 */
+	public function get_item_nav() {
+		$primary_nav_items = $this->get_primary( array( 'show_for_displayed_user' => true ) );
+
+		if ( $primary_nav_items ) {
+			foreach( $primary_nav_items as $key_nav => $primary_nav ) {
+				// Try to get the children
+				$children = $this->get_secondary( array( 'parent_slug' => $primary_nav->slug, 'user_has_access' => true ) );
+
+				if ( $children ) {
+					$primary_nav_items[ $key_nav ] = clone( $primary_nav );
+					$primary_nav_items[ $key_nav ]->children = $children;
+				}
+			}
+		}
+
+		return $primary_nav_items;
+	}
+}
Index: /trunk/src/bp-core/classes/class-bp-core.php
===================================================================
--- /trunk/src/bp-core/classes/class-bp-core.php	(revision 10744)
+++ /trunk/src/bp-core/classes/class-bp-core.php	(revision 10745)
@@ -254,4 +254,10 @@
 		// bp-notifications instead.
 		$bp->core->table_name_notifications = $bp->table_prefix . 'bp_notifications';
+
+		// Backward compatibility for plugins modifying the legacy bp_nav and bp_options_nav global properties.
+		if ( buddypress()->do_nav_backcompat ) {
+			$bp->bp_nav         = new BP_Core_BP_Nav_BackCompat();
+			$bp->bp_options_nav = new BP_Core_BP_Options_Nav_BackCompat();
+		}
 
 		/**
Index: /trunk/src/bp-core/deprecated/2.6.php
===================================================================
--- /trunk/src/bp-core/deprecated/2.6.php	(revision 10744)
+++ /trunk/src/bp-core/deprecated/2.6.php	(revision 10745)
@@ -22,2 +22,29 @@
 	<?php
 }
+
+/**
+ * Sort the navigation menu items.
+ *
+ * The sorting is split into a separate function because it can only happen
+ * after all plugins have had a chance to register their navigation items.
+ *
+ * @since 1.0.0
+ * @deprecated 2.6.0
+ *
+ * @return bool|null Returns false on failure.
+ */
+function bp_core_sort_nav_items() {
+	_deprecated_function( __FUNCTION__, '2.6' );
+}
+
+/**
+ * Sort all subnavigation arrays.
+ *
+ * @since 1.1.0
+ * @deprecated 2.6.0
+ *
+ * @return bool|null Returns false on failure.
+ */
+function bp_core_sort_subnav_items() {
+	_deprecated_function( __FUNCTION__, '2.6' );
+}
Index: /trunk/src/bp-groups/bp-groups-adminbar.php
===================================================================
--- /trunk/src/bp-groups/bp-groups-adminbar.php	(revision 10744)
+++ /trunk/src/bp-groups/bp-groups-adminbar.php	(revision 10745)
@@ -48,13 +48,13 @@
 
 	// Index of the Manage tabs parent slug.
-	$nav_index = $bp->groups->current_group->slug . '_manage';
+	$secondary_nav_items = $bp->groups->nav->get_secondary( array( 'parent_slug' => $bp->groups->current_group->slug . '_manage' ) );
 
 	// Check if current group has Manage tabs.
-	if ( empty( $bp->bp_options_nav[ $nav_index ] ) ) {
+	if ( ! $secondary_nav_items ) {
 		return;
 	}
 
 	// Build the Group Admin menus.
-	foreach ( $bp->bp_options_nav[ $nav_index ] as $menu ) {
+	foreach ( $secondary_nav_items as $menu ) {
 		/**
 		 * Should we add the current manage link in the Group's "Edit" Admin Bar menu ?
@@ -64,17 +64,17 @@
 		 * the 'show_in_admin_bar' argument of your edit screen to true
 		 */
-		if ( $menu['show_in_admin_bar'] ) {
-			$title = sprintf( _x( 'Edit Group %s', 'Group WP Admin Bar manage links', 'buddypress' ), $menu['name'] );
+		if ( $menu->show_in_admin_bar ) {
+			$title = sprintf( _x( 'Edit Group %s', 'Group WP Admin Bar manage links', 'buddypress' ), $menu->name );
 
 			// Title is specific for delete.
-			if ( 'delete-group' == $menu['slug'] ) {
-				$title = sprintf( _x( '%s Group', 'Group WP Admin Bar delete link', 'buddypress' ), $menu['name'] );
+			if ( 'delete-group' == $menu->slug ) {
+				$title = sprintf( _x( '%s Group', 'Group WP Admin Bar delete link', 'buddypress' ), $menu->name );
 			}
 
 			$wp_admin_bar->add_menu( array(
 				'parent' => $bp->group_admin_menu_id,
-				'id'     => $menu['slug'],
+				'id'     => $menu->slug,
 				'title'  => $title,
-				'href'   => bp_get_groups_action_link( 'admin/' . $menu['slug'] )
+				'href'   => bp_get_groups_action_link( 'admin/' . $menu->slug )
 			) );
 		}
Index: /trunk/src/bp-groups/classes/class-bp-group-extension.php
===================================================================
--- /trunk/src/bp-groups/classes/class-bp-group-extension.php	(revision 10744)
+++ /trunk/src/bp-groups/classes/class-bp-group-extension.php	(revision 10745)
@@ -738,5 +738,5 @@
 				'user_has_access' => $user_can_see_nav_item,
 				'no_access_url'   => $group_permalink,
-			) );
+			), 'groups' );
 		}
 
@@ -753,5 +753,5 @@
 				'user_has_access' => $user_can_visit,
 				'no_access_url'   => $group_permalink,
-			) );
+			), 'groups' );
 
 			// When we are viewing the extension display page, set the title and options title.
@@ -968,5 +968,5 @@
 
 		// Add the tab to the manage navigation.
-		bp_core_new_subnav_item( $subnav_args );
+		bp_core_new_subnav_item( $subnav_args, 'groups' );
 
 		// Catch the edit screen and forward it to the plugin template.
Index: /trunk/src/bp-groups/classes/class-bp-groups-component.php
===================================================================
--- /trunk/src/bp-groups/classes/class-bp-groups-component.php	(revision 10744)
+++ /trunk/src/bp-groups/classes/class-bp-groups-component.php	(revision 10745)
@@ -253,4 +253,7 @@
 			// Check once if the current group has a custom front template.
 			$this->current_group->front_template = bp_groups_get_front_template( $this->current_group );
+
+			// Initialize the nav for the groups component.
+			$this->nav = new BP_Core_Nav( $this->current_group->id );
 
 		// Set current_group to 0 to prevent debug errors.
@@ -497,6 +500,9 @@
 			$sub_nav = array();
 
-			// Add 'Groups' to the main navigation.
-			$main_nav = array(
+			/*
+			 * The top-level Groups item is called 'Memberships' for legacy reasons.
+			 * It does not appear in the interface.
+			 */
+			bp_core_new_nav_item( array(
 				'name'                => __( 'Memberships', 'buddypress' ),
 				'slug'                => $this->current_group->slug,
@@ -505,5 +511,5 @@
 				'default_subnav_slug' => $this->default_extension,
 				'item_css_id'         => $this->id
-			);
+			), 'groups' );
 
 			$group_link = bp_get_group_permalink( $this->current_group );
@@ -676,5 +682,7 @@
 			}
 
-			parent::setup_nav( $main_nav, $sub_nav );
+			foreach ( $sub_nav as $nav ) {
+				bp_core_new_subnav_item( $nav, 'groups' );
+			}
 		}
 
Index: /trunk/src/bp-loader.php
===================================================================
--- /trunk/src/bp-loader.php	(revision 10744)
+++ /trunk/src/bp-loader.php	(revision 10745)
@@ -110,4 +110,12 @@
 	public $do_autoload = false;
 
+	/**
+	 * Whether to load backward compatibility classes for navigation globals.
+	 *
+	 * @since 2.6.0
+	 * @var bool
+	 */
+	public $do_nav_backcompat = false;
+
 	/** Option Overload *******************************************************/
 
@@ -435,4 +443,10 @@
 		$this->email_post_type     = apply_filters( 'bp_email_post_type', 'bp-email' );
 		$this->email_taxonomy_type = apply_filters( 'bp_email_tax_type', 'bp-email-type' );
+
+		/** Navigation backward compatibility *********************************/
+		if ( interface_exists( 'ArrayAccess', false ) ) {
+			// bp_nav and bp_options_nav compatibility depends on SPL.
+			$this->do_nav_backcompat = true;
+		}
 	}
 
Index: /trunk/src/bp-members/bp-members-template.php
===================================================================
--- /trunk/src/bp-members/bp-members-template.php	(revision 10744)
+++ /trunk/src/bp-members/bp-members-template.php	(revision 10745)
@@ -1291,10 +1291,10 @@
 
 	// Loop through each navigation item.
-	foreach( (array) $bp->bp_nav as $nav_item ) {
+	foreach ( (array) $bp->members->nav->get_primary() as $nav_item ) {
 
 		$selected = '';
 
 		// If the current component matches the nav item id, then add a highlight CSS class.
-		if ( !bp_is_directory() && !empty( $bp->active_components[bp_current_component()] ) && $bp->active_components[bp_current_component()] == $nav_item['css_id'] ) {
+		if ( ! bp_is_directory() && ! empty( $bp->active_components[ bp_current_component() ] ) && $bp->active_components[ bp_current_component() ] == $nav_item->css_id ) {
 			$selected = ' class="current selected"';
 		}
@@ -1308,5 +1308,5 @@
 
 			if ( bp_is_active( 'friends' ) ) {
-				if ( $nav_item['css_id'] == $bp->friends->id ) {
+				if ( $nav_item->css_id == $bp->friends->id ) {
 					if ( friends_check_friendship( bp_loggedin_user_id(), bp_displayed_user_id() ) ) {
 						$selected = ' class="current selected"';
@@ -1317,5 +1317,5 @@
 
 		// Echo out the final list item.
-		echo apply_filters_ref_array( 'bp_get_loggedin_user_nav_' . $nav_item['css_id'], array( '<li id="li-nav-' . $nav_item['css_id'] . '" ' . $selected . '><a id="my-' . $nav_item['css_id'] . '" href="' . $nav_item['link'] . '">' . $nav_item['name'] . '</a></li>', &$nav_item ) );
+		echo apply_filters_ref_array( 'bp_get_loggedin_user_nav_' . $nav_item->css_id, array( '<li id="li-nav-' . $nav_item->css_id . '" ' . $selected . '><a id="my-' . $nav_item->css_id . '" href="' . $nav_item->link . '">' . $nav_item->name . '</a></li>', &$nav_item ) );
 	}
 
@@ -1334,17 +1334,18 @@
 	$bp = buddypress();
 
-	foreach ( (array) $bp->bp_nav as $user_nav_item ) {
-		if ( empty( $user_nav_item['show_for_displayed_user'] ) && !bp_is_my_profile() )
+	foreach ( $bp->members->nav->get_primary() as $user_nav_item ) {
+		if ( empty( $user_nav_item->show_for_displayed_user ) && ! bp_is_my_profile() ) {
 			continue;
+		}
 
 		$selected = '';
-		if ( bp_is_current_component( $user_nav_item['slug'] ) ) {
+		if ( bp_is_current_component( $user_nav_item->slug ) ) {
 			$selected = ' class="current selected"';
 		}
 
 		if ( bp_loggedin_user_domain() ) {
-			$link = str_replace( bp_loggedin_user_domain(), bp_displayed_user_domain(), $user_nav_item['link'] );
+			$link = str_replace( bp_loggedin_user_domain(), bp_displayed_user_domain(), $user_nav_item->link );
 		} else {
-			$link = trailingslashit( bp_displayed_user_domain() . $user_nav_item['link'] );
+			$link = trailingslashit( bp_displayed_user_domain() . $user_nav_item->link );
 		}
 
@@ -1360,5 +1361,5 @@
 		 *                              Passed by reference.
 		 */
-		echo apply_filters_ref_array( 'bp_get_displayed_user_nav_' . $user_nav_item['css_id'], array( '<li id="' . $user_nav_item['css_id'] . '-personal-li" ' . $selected . '><a id="user-' . $user_nav_item['css_id'] . '" href="' . $link . '">' . $user_nav_item['name'] . '</a></li>', &$user_nav_item ) );
+		echo apply_filters_ref_array( 'bp_get_displayed_user_nav_' . $user_nav_item->css_id, array( '<li id="' . $user_nav_item->css_id . '-personal-li" ' . $selected . '><a id="user-' . $user_nav_item->css_id . '" href="' . $link . '">' . $user_nav_item->name . '</a></li>', &$user_nav_item ) );
 	}
 }
Index: /trunk/src/bp-members/classes/class-bp-members-component.php
===================================================================
--- /trunk/src/bp-members/classes/class-bp-members-component.php	(revision 10744)
+++ /trunk/src/bp-members/classes/class-bp-members-component.php	(revision 10745)
@@ -151,4 +151,7 @@
 		$bp->displayed_user->domain   = bp_core_get_user_domain( bp_displayed_user_id() );
 
+		// Initialize the nav for the members component.
+		$this->nav = new BP_Core_Nav();
+
 		/** Signup ***********************************************************
 		 */
Index: /trunk/src/bp-messages/bp-messages-screens.php
===================================================================
--- /trunk/src/bp-messages/bp-messages-screens.php	(revision 10744)
+++ /trunk/src/bp-messages/bp-messages-screens.php	(revision 10745)
@@ -133,5 +133,8 @@
 	$nav_name = sprintf( __( 'Messages <span class="%s">%s</span>', 'buddypress' ), esc_attr( $class ), bp_core_number_format( $count ) );
 
-	$bp->bp_nav[ $bp->messages->slug ]['name'] = $nav_name;
+	// Edit the Navigation name.
+	$bp->members->nav->edit_nav( array(
+		'name' => $nav_name,
+	), $bp->messages->slug );
 
 	/**
Index: /trunk/src/bp-xprofile/classes/class-bp-xprofile-component.php
===================================================================
--- /trunk/src/bp-xprofile/classes/class-bp-xprofile-component.php	(revision 10744)
+++ /trunk/src/bp-xprofile/classes/class-bp-xprofile-component.php	(revision 10745)
@@ -303,5 +303,5 @@
 			'position'        => 30,
 			'user_has_access' => bp_core_can_edit_settings()
-		) );
+		), 'members' );
 	}
 
Index: /trunk/tests/phpunit/testcases/core/nav/backCompat.php
===================================================================
--- /trunk/tests/phpunit/testcases/core/nav/backCompat.php	(revision 10745)
+++ /trunk/tests/phpunit/testcases/core/nav/backCompat.php	(revision 10745)
@@ -0,0 +1,321 @@
+<?php
+
+/**
+ * @group core
+ * @group nav
+ * @ticket BP6534
+ * @expectedIncorrectUsage bp_nav
+ */
+class BP_Core_Nav_BackCompat extends BP_UnitTestCase {
+	protected $bp_nav;
+	protected $bp_options_nav;
+
+	public function setUp() {
+		parent::setUp();
+		$this->bp_nav = buddypress()->bp_nav;
+		$this->bp_options_nav = buddypress()->bp_options_nav;
+	}
+
+	public function tearDown() {
+		buddypress()->bp_nav = $this->bp_nav;
+		buddypress()->bp_options_nav = $this->bp_options_nav;
+		parent::tearDown();
+	}
+
+	protected function create_nav_items() {
+		bp_core_new_nav_item( array(
+			'name'                => 'Foo',
+			'slug'                => 'foo',
+			'position'            => 25,
+			'screen_function'     => 'foo_screen_function',
+			'default_subnav_slug' => 'foo-subnav'
+		) );
+
+		bp_core_new_subnav_item( array(
+			'name'            => 'Foo Subnav',
+			'slug'            => 'foo-subnav',
+			'parent_url'      => 'example.com/foo',
+			'parent_slug'     => 'foo',
+			'screen_function' => 'foo_screen_function',
+			'position'        => 10
+		) );
+	}
+
+	/**
+	 * Create a group, set up nav item, and go to the group.
+	 */
+	protected function set_up_group() {
+		$g = $this->factory->group->create( array(
+			'slug' => 'testgroup',
+		) );
+
+		$group = groups_get_group( array( 'group_id' => $g ) );
+		$group_permalink = bp_get_group_permalink( $group );
+
+		$this->go_to( $group_permalink );
+
+		bp_core_new_subnav_item( array(
+			'name'            => 'Foo',
+			'slug'            => 'foo',
+			'parent_url'      => $group_permalink,
+			'parent_slug'     => 'testgroup',
+			'screen_function' => 'foo_screen_function',
+			'position'        => 10
+		), 'groups' );
+	}
+
+	public function test_bp_nav_isset() {
+		$this->create_nav_items();
+
+		$bp = buddypress();
+
+		$this->assertTrue( isset( $bp->bp_nav ) );
+		$this->assertTrue( isset( $bp->bp_nav['foo'] ) );
+		$this->assertTrue( isset( $bp->bp_nav['foo']['name'] ) );
+	}
+
+	public function test_bp_nav_unset() {
+		$this->create_nav_items();
+
+		$bp = buddypress();
+
+		// No support for this - it would create a malformed nav item.
+		/*
+		unset( $bp->bp_nav['foo']['css_id'] );
+		$this->assertFalse( isset( $bp->bp_nav['foo']['css_id'] ) );
+		*/
+
+		unset( $bp->bp_nav['foo'] );
+		$this->assertFalse( isset( $bp->bp_nav['foo'] ) );
+	}
+
+	public function test_bp_nav_get() {
+		$this->create_nav_items();
+
+		$bp = buddypress();
+
+		$foo = $bp->bp_nav['foo'];
+		$this->assertSame( 'Foo', $foo['name'] );
+
+		$this->assertSame( 'Foo', $bp->bp_nav['foo']['name'] );
+	}
+
+	public function test_bp_nav_set() {
+		$this->create_nav_items();
+
+		$bp = buddypress();
+
+		$bp->bp_nav['foo']['name'] = 'Bar';
+
+		$nav = bp_get_nav_menu_items();
+
+		foreach ( $nav as $_nav ) {
+			if ( 'foo' === $_nav->css_id ) {
+				$found = $_nav;
+				break;
+			}
+		}
+
+		$this->assertSame( 'Bar', $found->name );
+	}
+
+	public function test_bp_options_nav_isset() {
+		$this->create_nav_items();
+
+		$bp = buddypress();
+
+		$this->assertTrue( isset( $bp->bp_options_nav ) );
+		$this->assertTrue( isset( $bp->bp_options_nav['foo'] ) );
+		$this->assertTrue( isset( $bp->bp_options_nav['foo']['foo-subnav'] ) );
+		$this->assertTrue( isset( $bp->bp_options_nav['foo']['foo-subnav']['name'] ) );
+	}
+
+	public function test_bp_options_nav_unset() {
+		$this->create_nav_items();
+
+		$bp = buddypress();
+
+		// No support for this - it would create a malformed nav item.
+		/*
+		unset( $bp->bp_options_nav['foo']['foo-subnav']['user_has_access'] );
+		$this->assertFalse( isset( $bp->bp_options_nav['foo']['foo-subnav']['user_has_access'] ) );
+		*/
+
+		unset( $bp->bp_options_nav['foo']['foo-subnav'] );
+		$this->assertFalse( isset( $bp->bp_options_nav['foo']['foo-subnav'] ) );
+
+		// Make sure the parent nav hasn't been wiped out.
+		$this->assertTrue( isset( $bp->bp_options_nav['foo'] ) );
+
+		unset( $bp->bp_options_nav['foo'] );
+		$this->assertFalse( isset( $bp->bp_options_nav['foo'] ) );
+	}
+
+	public function test_bp_options_nav_get() {
+		$this->create_nav_items();
+
+		$bp = buddypress();
+
+		$foo_subnav = $bp->bp_options_nav['foo']['foo-subnav'];
+		$this->assertSame( 'Foo Subnav', $foo_subnav['name'] );
+
+		$this->assertSame( 'Foo Subnav', $bp->bp_options_nav['foo']['foo-subnav']['name'] );
+	}
+
+	public function test_bp_options_nav_set() {
+		$this->create_nav_items();
+
+		$bp = buddypress();
+
+		$bp->bp_options_nav['foo']['foo-subnav']['name'] = 'Bar';
+		$nav = bp_get_nav_menu_items();
+
+		foreach ( $nav as $_nav ) {
+			if ( 'foo-subnav' === $_nav->css_id ) {
+				$found = $_nav;
+				break;
+			}
+		}
+
+		$this->assertSame( 'Bar', $found->name );
+
+		$subnav = array(
+			'name' => 'Bar',
+			'css_id' => 'bar-id',
+			'link' => 'bar-link',
+			'slug' => 'bar-slug',
+			'user_has_access' => true,
+		);
+		$bp->bp_options_nav['foo']['foo-subnav'] = $subnav;
+		$nav = bp_get_nav_menu_items();
+
+		foreach ( $nav as $_nav ) {
+			if ( 'bar-id' === $_nav->css_id ) {
+				$found = $_nav;
+				break;
+			}
+		}
+
+		$this->assertSame( 'Bar', $found->name );
+	}
+
+	/**
+	 * @group groups
+	 */
+	public function test_bp_options_nav_isset_group_nav() {
+		$this->set_up_group();
+
+		$bp = buddypress();
+
+		$this->assertTrue( isset( $bp->bp_options_nav ) );
+		$this->assertTrue( isset( $bp->bp_options_nav['testgroup'] ) );
+		$this->assertTrue( isset( $bp->bp_options_nav['testgroup']['foo'] ) );
+		$this->assertTrue( isset( $bp->bp_options_nav['testgroup']['foo']['name'] ) );
+	}
+
+	/**
+	 * @group groups
+	 */
+	public function test_bp_options_nav_unset_group_nav() {
+		$this->set_up_group();
+
+		$bp = buddypress();
+
+		// No support for this - it would create a malformed nav item.
+		/*
+		unset( $bp->bp_options_nav['testgroup']['foo']['user_has_access'] );
+		$this->assertFalse( isset( $bp->bp_options_nav['testgroup']['foo']['user_has_access'] ) );
+		*/
+
+		unset( $bp->bp_options_nav['testgroup']['foo'] );
+		$this->assertFalse( isset( $bp->bp_options_nav['testgroup']['foo'] ) );
+
+		unset( $bp->bp_options_nav['testgroup'] );
+		$this->assertFalse( isset( $bp->bp_options_nav['testgroup'] ) );
+	}
+
+	/**
+	 * @group groups
+	 */
+	public function test_bp_options_nav_get_group_nav() {
+		$this->set_up_group();
+
+		$bp = buddypress();
+
+		$foo = $bp->bp_options_nav['testgroup']['foo'];
+		$this->assertSame( 'Foo', $foo['name'] );
+
+		$this->assertSame( 'Foo', $bp->bp_options_nav['testgroup']['foo']['name'] );
+	}
+
+	/**
+	 * @group groups
+	 */
+	public function test_bp_options_nav_set_group_nav() {
+		$this->set_up_group();
+
+		$bp = buddypress();
+
+		$bp->bp_options_nav['testgroup']['foo']['name'] = 'Bar';
+		$nav = bp_get_nav_menu_items( 'groups' );
+
+		foreach ( $nav as $_nav ) {
+			if ( 'foo' === $_nav->css_id ) {
+				$found = $_nav;
+				break;
+			}
+		}
+
+		$this->assertSame( 'Bar', $found->name );
+
+		$subnav = array(
+			'name' => 'Bar',
+			'css_id' => 'bar-id',
+			'link' => 'bar-link',
+			'slug' => 'bar-slug',
+			'user_has_access' => true,
+		);
+		$bp->bp_options_nav['testgroup']['foo'] = $subnav;
+		$nav = bp_get_nav_menu_items( 'groups' );
+
+		foreach ( $nav as $_nav ) {
+			if ( 'bar-id' === $_nav->css_id ) {
+				$found = $_nav;
+				break;
+			}
+		}
+
+		$this->assertSame( 'Bar', $found->name );
+	}
+
+	/**
+	 * @group groups
+	 */
+	public function test_bp_core_new_subnav_item_should_work_in_group_context() {
+		$this->set_up_group();
+
+		bp_core_new_subnav_item( array(
+			'name' => 'Foo Subnav',
+			'slug' => 'foo-subnav',
+			'parent_slug' => bp_get_current_group_slug(),
+			'parent_url' => bp_get_group_permalink( groups_get_current_group() ),
+			'screen_function' => 'foo_subnav',
+		) );
+
+		$bp = buddypress();
+
+		// Touch bp_nav since we told PHPUnit it was expectedDeprecated.
+		$f = $bp->bp_options_nav[ bp_get_current_group_slug() ];
+
+		$nav = bp_get_nav_menu_items( 'groups' );
+
+		foreach ( $nav as $_nav ) {
+			if ( 'foo-subnav' === $_nav->css_id ) {
+				$found = $_nav;
+				break;
+			}
+		}
+
+		$this->assertSame( 'Foo Subnav', $found->name );
+	}
+}
